# $Id: composenamefrommods.py 2969 2010-01-25 14:31:42Z anton $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-8.1.0/src/delfttilburg/composenamefrommods.py $
## begin license ##
#
#    "Delft-Tilburg" (delfttilburg) is a package containing shared code
#    between the Delft "Discover" and Tilburg "Beter Zoeken & Vinden" projects.
#    Both projects are based on Meresco Software (http://meresco.com)
#    Copyright (C) 2008-2009 Technische Universiteit Delft http://www.tudelft.nl
#    Copyright (C) 2008-2009 Universiteit van Tilburg http://www.uvt.nl
#    Copyright (C) 2008-2009 Seek You Too (CQ2) http://www.cq2.nl
#
#    This file is part of "Delft-Tilburg".
#
#    "Delft-Tilburg" is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    "Delft-Tilburg" is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with "Delft-Tilburg"; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
## end license ##

from merescocore.framework import Observable

class ComposeNameFromMods(Observable):
    def __init__(self, fieldName):
        Observable.__init__(self)
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3'}
        self._fieldName = fieldName

    def add(self, id, partName, lxmlNode):
        names = lxmlNode.xpath('//mods:name', namespaces=self._namespaceMap)
        for name in names:
            familyName = name.xpath('mods:namePart[@type="family"]/text()', namespaces=self._namespaceMap)
            givenName = name.xpath('mods:namePart[@type="given"]/text()', namespaces=self._namespaceMap)

            value = ''
            if len(familyName) == len(givenName) == 1:
                value = familyName[0] + ', ' + givenName[0]
            else:
                nameParts = name.xpath('mods:namePart/text()', namespaces=self._namespaceMap)
                value=' '.join(nameParts)

            if value:
                yield self.all.addField(name=self._fieldName, value=str(value))
